package com.zanxiang.game.module.manage.rpc.impl;

import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.zanxiang.game.module.base.pojo.dto.GameDTO;
import com.zanxiang.game.module.base.rpc.IGameRpc;
import com.zanxiang.game.module.manage.service.IGameService;
import com.zanxiang.game.module.mybatis.entity.Game;
import com.zanxiang.module.util.bean.BeanUtil;
import com.zanxiang.module.util.pojo.ResultVO;
import org.apache.dubbo.config.annotation.DubboService;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @author : lingfeng
 * @time : 2024-05-23
 * @description : 游戏相关接口
 */
@DubboService
public class GameRpcImpl implements IGameRpc {

    @Autowired
    private IGameService gameService;

    @Override
    public ResultVO<List<GameDTO>> getAllGameList() {
        List<Game> gameList = gameService.list();
        if (CollectionUtils.isEmpty(gameList)) {
            return ResultVO.ok(Collections.emptyList());
        }
        return ResultVO.ok(gameList.stream().map(game -> BeanUtil.copy(game, GameDTO.class)).collect(Collectors.toList()));
    }
}
